unit SandColr;
// The colors dialog box

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TColorForm = class(TForm)
    OkButton: TButton;
    CancelButton: TButton;
    ColorDialog1: TColorDialog;
    GroupBox1: TGroupBox;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    DefaultButton: TButton;
    GroupBox2: TGroupBox;
    GridCheckBox: TCheckBox;
    procedure FormActivate(Sender: TObject);
    procedure PanelClick(Sender: TObject);
    procedure DefaultButtonClick(Sender: TObject);
  end;

var
  ColorForm: TColorForm;

implementation

{$R *.DFM}

uses
  SandMain;

{--------------------- TEditForm ----------------------}

procedure TColorForm.FormActivate(Sender: TObject);
begin
  ActiveControl := OkButton;
  with MainForm do
  begin
    // Get colors
    Panel1.Color := Colors[1];
    Panel2.Color := Colors[2];
    Panel3.Color := Colors[3];
    Panel4.Color := Colors[4];
    Panel5.Color := Colors[5];
    Panel6.Color := Colors[6];
    // Get grid settings
    GridCheckBox.Checked := ShowGrid;
  end;
end;


procedure TColorForm.PanelClick(Sender: TObject);
begin
  ColorDialog1.Color := (Sender as TPanel).Color;
  if ColorDialog1.Execute then
  with (Sender as TPanel) do
    Color := ColorDialog1.Color;
end;


procedure TColorForm.DefaultButtonClick(Sender: TObject);
const
  DefaultColors: array[1..6] of Longint =
    (clWhite, clSilver, clBlue, clNavy, clYellow, clBlack);
begin
  if MessageDlg('Do you want to restore the default palette?', mtInformation,
                [mbYes, mbNo], 0) = mrYes then
  begin
    Panel1.Color := DefaultColors[1];
    Panel2.Color := DefaultColors[2];
    Panel3.Color := DefaultColors[3];
    Panel4.Color := DefaultColors[4];
    Panel5.Color := DefaultColors[5];
    Panel6.Color := DefaultColors[6];
  end;
  ActiveControl := OkButton;
end;

end.

