unit SandLog;
// An abstract class you can use to create logfiles.
// See sandsim.pas for an example of a log file object.

interface

uses
  Classes;

type
  TLog = class
  public
    constructor Create(const F: String);
    destructor Destroy; override;
    procedure Log; virtual; abstract;
    procedure Save;
    procedure LogTime(Tm: TDateTime);
  protected
    FileName: String;
    LogList: TStringList;
  end;

implementation

uses
  SysUtils;

{----------------------- TLog -------------------------}

constructor TLog.Create(const F: String);
begin
  inherited Create;
  LogList := TStringList.Create;
  FileName := F;
end;


destructor TLog.Destroy;
begin
  LogList.Free;
  inherited Destroy;
end;


procedure TLog.Save;
begin
  LogList.SaveToFile(FileName);
end;


procedure TLog.LogTime(Tm: TDateTime);
begin
  LogList.Add(TimeToStr(Tm));
end;

end.

